package battotal;

sub BATTOTAL{
	 my ($self, $myconfig, $form) = @_;
if ($form->{datefrom}) {
    $glwhere .= " AND acc_trans.transdate >= '$form->{datefrom}'";
    $gpwhere .= " AND transdate >= '$form->{datefrom}'";
  }
  if ($form->{dateto}) {
    $glwhere .= " AND acc_trans.transdate <= '$form->{dateto}'";
    $gpwhere .= " AND transdate <= '$form->{dateto}'";
  }
  # connect to database
  	my $dbh = $form->dbconnect($myconfig);

	my $where = "1 = 1";
	$form->{sort} = "template" unless ($form->{sort}); 
  
  	my $query = qq~ SELECT notr1+notr2 as notr, t1.transtype, t1.batch, t1.debit, t2.credit from 
	                (SELECT  count(acc_trans.trans_id) as notr1 , gl.transtype, gl.batch, 0 as debit
			FROM acc_trans, gl
			WHERE gl.id = acc_trans.trans_id and amount < 0 and gl.transtype='OB' $glwhere
			GROUP BY  gl.transtype, gl.batch) as t1
			
			full outer join 
			
			(SELECT COUNT(acc_trans.trans_id) as notr2, gl.transtype, gl.batch, 0 as credit 
			FROM acc_trans, gl
			WHERE gl.id = acc_trans.trans_id and amount > 0 and gl.transtype='OB' $glwhere
			GROUP BY  gl.transtype, gl.batch) as t2
			
			on (t1.transtype=t2.transtype and t1.batch=t2.batch)
			
			UNION ALL
			
			SELECT notr1+notr2 as notr,t1.transtype,t1.batch,t1.debit,t2.credit from 
	                (SELECT  count(acc_trans.trans_id) as notr1 , gl.transtype, gl.batch, sum((acc_trans.amount)*-1) as debit
			FROM acc_trans, gl
			WHERE gl.id = acc_trans.trans_id and amount < 0 and gl.transtype<>'OB' $glwhere
			GROUP BY  gl.transtype, gl.batch) as t1
			
			full outer join 
			
			(SELECT COUNT(acc_trans.trans_id) as notr2, gl.transtype, gl.batch, sum((acc_trans.amount)*-1) as credit 
			FROM acc_trans, gl
			WHERE gl.id = acc_trans.trans_id and amount > 0 and gl.transtype<>'OB' $glwhere
			GROUP BY  gl.transtype, gl.batch) as t2
			
			on (t1.transtype=t2.transtype and t1.batch=t2.batch)
			
			UNION ALL
			
			(SELECT notr1+notr2 as notr, t1.transtype, t1.batch, t1.debit, t2.credit from
			(SELECT  COUNT(gp_trans.id)-1 as notr1 , gp.transtype, gp.batch, sum((gp_trans.amount)*-1) as debit 
  			FROM  gp_trans , gp
			WHERE gp.id = gp_trans.id and amount < 0  $gpwhere
			GROUP BY  gp.transtype,gp.batch) as t1
			
			full outer join
			
			(SELECT  COUNT(gp_trans.id) as notr2 , gp.transtype, gp.batch, 0, sum((gp_trans.amount)*-1) as credit 
  			FROM  gp_trans , gp
			WHERE gp.id = gp_trans.id and amount > 0  $gpwhere
			GROUP BY   gp.transtype,gp.batch) as t2
			
			on (t1.transtype=t2.transtype and t1.batch=t2.batch)
			ORDER BY transtype)~;

			my $sth = $dbh->prepare($query);
			$sth->execute || $form->dberror($query);
 #$form->dberror($query);
	while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
		push @{ $form->{GL} }, $ref;
	}

	$sth->finish;
	$dbh->disconnect;
}

1;
