#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Genereal Ledger
#
#======================================================================


use SL::dataentry3;
use SL::GL;

1;

sub add {

 if($form->{transdate}){
 $lastbatch = $form->{batch};
 #$lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  GL->transaction(\%myconfig, \%$form);

if($lastdate){
 #$form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}



  $form->{title} = "Add";

  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&login=$form->{login}&password=$form->{password}&arap=$form->{arap}";

 if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  dataentry3->transaction(\%myconfig, \%$form);

if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}

  $form->{rowcount} = 1;
   #  $form->{debit_credit1}= "<option selected>Debit<option>Credit";
  &display_form;

}

sub edit {


  dataentry3->transaction(\%myconfig, \%$form);

  $form->{locked} = ($form->datetonum($form->{transdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));

  $form->{title} = "Edit";
  
  
#  my $debit_credit;


  $i = 1;

&form_header;

  foreach $ref (@{ $form->{dataentry3} }) {
    $form->{"accno_$i"} = $ref->{accno};
    $form->{"source_$i"} = $ref->{source};
    $form->{"description_$i"} = $ref->{description};
    $form->{"transdate_$i"} = $ref->{transdate};
    $form->{"transno_$i"} = $ref->{transno};
    $form->{"subtransno_$i"} = $ref->{subtransno};
    if($ref->{amount} < 0){
    $form->{"debit_$i"} = $ref->{amount}*-1;
    }else{
    $form->{"credit_$i"} = $ref->{amount};
    }



    &form_row($i++);
  }

  &form_row($i);

  &form_footer;
}

sub display_form {

  &form_header;
  $form->{rowcount}++;

  for $i (1 .. $form->{rowcount}) {
    if($i == 1){
    	$form->{"transtype_$i"}=$form->{"transtype"};
	if(!$form->{"transno_$i"}){
    		$form->{"transno_$i"}=$form->{"transno"};
	}
	if(!$form->{"transdate_$i"}){
    		$form->{"transdate_$i"}=$form->{"transdate"};
	}
	$form->{"invnumber_$i"}=$form->{prefix}.1;
 #	$form->{"invnumber_$i"}++;
   }
    if($i == $form->{rowcount}){
    	$y = $form->{rowcount}-1;
    	$form->{"transtype_$i"}=$form->{"transtype_$y"};
    	$form->{"batch_$i"}=$form->{"batch_$y"};
	$form->{"transno_$i"}=$form->{"transno_$y"};
    	$form->{"transno_$i"}++;
    	$form->{"subtransno_$i"}=$form->{"subtransno_$y"};
    	$form->{"transdate_$i"}=$form->{"transdate_$y"};
     	$form->{"invnumber_$i"}=$form->{"invnumber_$y"};
	$form->{"invnumber_$i"}++;

   }
if(!$form->{"source_$i"}){
$form->{"source_$i"}=$form->{"source"};
}
	
	&form_row($i);
  }



  if(!$form->{"nextfocus"}){
	$form->{"nextfocus"}  = "transno_$form->{rowcount}";
 }

  &form_footer;

}



sub form_row {
 my $i = shift;

  my $chart;

  foreach $item (split /\n/, $form->{chart}) {


    ($key, $value) = split /--/, $item;

	if($form->{"accno1_$i"}){
		$form->{"accno_$i"}=$form->{"accno1_$i"} ;
	}

		if ($key == $form->{"accno_$i"}) {
      			$chart .= "<option selected value='$key--$value'>$key--$value\n";

   		} else {



			if($form->{"accno1_$i"} eq ''){
					$chart .= "<option value='$key--$value'>$key--$value\n";

			}else{
				if ($key =~ /^$form->{"accno1_$i"}/){
					$chart .= "<option value='$key--$value'>$key--$value\n";
				}
			}

		}


  }


$totaldebit +=$form->{"debit_$i"};
$totalcredit +=$form->{"credit_$i"};
  print qq|<tr>
  <td>$i</td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transno_$i"  size=4 value="$form->{"transno_$i"}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subtransno  size=2 value="$form->{"subtransno_$i"}"></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transdate_$i" size=10 value=$form->{"transdate_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" size=10 value=$form->{"source_$i"}></td>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="accno_$i">$chart</select></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="description_$i" size=10 value=$form->{"description_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="debit_$i" size=10 value=$form->{"debit_$i"}></td>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="credit_$i" size=10 value=$form->{"credit_$i"}></td>

</tr>
<input type=hidden name=rowcount value=$i>


|;


}


sub form_header {
 my $chart;
 my $total;
$total=0;


  $title = $form->{title};
  $form->{title} = $locale->text("$title ");

# $locale->text('Add General Ledger Transaction')
# $locale->text('Edit General Ledger Transaction')

  map { $form->{$_} =~ s/"/&quot;/g } qw(source description chart);

  if (($rows = $form->numtextrows($form->{description}, 50)) > 1) {
    $description = qq|<textarea name=description rows=$rows cols=50 wrap=soft>$form->{description}</textarea>|;
  } else {
    $description = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=description size=50 value="$form->{description}">|;
  }


  $colspan = 8;

if(!$form->{nextfocus}){
	$form->{nextfocus}="transtype";
}
  $form->header;

  print qq|
<script>
<!--
function stb(){document.myform.$form->{nextfocus}.focus();}

function autoComplete (field, select, property, forcematch) {
	var found = false;
	for (var i = 0; i < select.options.length; i++) {
	if (select.options[i][property].toUpperCase().indexOf(field.value.toUpperCase()) == 0) {
		found=true; break;
		}
	}
	if (found) { select.selectedIndex = i; }
	else { select.selectedIndex = -1; }
	if (field.createTextRange) {
		if (forcematch && !found) {
			field.value=field.value.substring(0,field.value.length-1); 
			return;
			}
		var cursorKeys ="8;46;37;38;39;40;33;34;35;36;45;";
		if (cursorKeys.indexOf(event.keyCode+";") == -1) {
			var r1 = field.createTextRange();
			var oldValue = r1.text;
			var newValue = found ? select.options[i][property] : oldValue;
			if (newValue != field.value) {
				field.value = newValue;
				var rNew = field.createTextRange();
				rNew.moveStart('character', oldValue.length) ;
				rNew.select();
				}
			}
		}
	}
	
	
// -->
</script>

<body bgcolor=ffffff onLoad=stb()>

<form method=post name=myform action=$form->{script}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=id type=hidden value=$form->{id}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=accno type=hidden value=$form->{accno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=salesaccno type=hidden value=$form->{salesaccno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=cashaccno type=hidden value=$form->{cashaccno}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=in_out type=hidden value=$form->{in_out}>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=customer_number type=hidden value=$form->{customer_number}>
<input type=hidden name=arap value=$form->{arap}>
<input type=hidden name=prefix value=$form->{prefix}>


<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=chart type=hidden value="$form->{chart}">
<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=title value="$title">
<input type=hidden name=source value="$form->{source}">
<input type=hidden name=keys >
<table border=1>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>
<table border=0>



<th align=right>|.$locale->text('Batch').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="transtype" size=5 value=$form->{"transtype"}>-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="batch" size=5 value=$form->{"batch"}></td>
</tr>


</table>
</td></tr>

<tr class=listheading bgcolor=336666>

  <th><font color=ffffff>|.$locale->text('No.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Trans No.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Date').qq|($myconfig{dateformat})</th>
  <th><font color=ffffff>|.$locale->text('Source.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Account.').qq|</th>
  <th><font color=ffffff>|.$locale->text('Description').qq|</th>
  <th><font color=ffffff>|.$locale->text('Debit').qq|</th>
  <th><font color=ffffff>|.$locale->text('Credit').qq|</th>

</tr>
|;

}


sub form_footer {

  print qq|
<tr class=listsubtotal bgcolor=336666>

  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th><font color=ffffff>&nbsp;</th>
  <th align=right><font color=ffffff>$totaldebit</th>
  <th align=right><font color=ffffff>$totalcredit</th>

</tr>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=nextfocus type=hidden value="$form->{nextfocus}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

</table>

<br>
|;

  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);

  if ($form->{id}) {
    print qq|<input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">
|;

    if (!$form->{revtrans}) {
    #  if (!$form->{locked}) {
	print qq|
	<input class=submit type=submit name=action value="|.$locale->text('Post Transaction').qq|">
	<input class=submit type=submit name=action value="|.$locale->text('Delete Transaction').qq|">
|;
      }
   # }

    if ($transdate > $closedto) {
      print qq|
      <input class=submit type=submit name=action value="|.$locale->text('Post As New Transaction').qq|">
|;
    }

  } else {
    if ($transdate > $closedto) {
      print qq|<input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">
      <input class=submit type=submit name=action value="|.$locale->text('Post Transaction').qq|">|;
    }
  }

  print "</form>

</body>
</html>
";

}


sub update_form {
 if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  dataentry3->transaction(\%myconfig, \%$form);

if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}


  @a = ();
  $count = 0;
  @flds = (qw(transno transtype batch subtransno transdate invnumber debit credit ));

  for $i (1 .. $form->{rowcount}) {
    unless ( ($form->{"credit_$i"} eq "") && ($form->{"debit_$i"} eq "")) {
      # take accno apart
    #  if($form->{"accno1_$i"}){
	#($form->{"accno_$i"}) =($form->{"accno1_$i"})
    #  }else{
     # ($form->{"accno_$i"}) = split(/--/, $form->{"accno_$i"});
    # }

      push @a, {};
      $j = $#a;

      map { $a[$j]->{$_} = $form->{"${_}_$i"} } @flds;
      $count++;
    }
  }

  for $i (1 .. $count) {
    $j = $i - 1;
    map { $form->{"${_}_$i"} = $a[$j]->{$_} } @flds;
  }

  for $i ($count + 1 .. $form->{rowcount}) {
    map { delete $form->{"${_}_$i"} } @flds;
  }

  $form->{rowcount} = $count;

	$x =$form->{rowcount}+1;
	$form->{"nextfocus"}  = "transno_$x";

   	&display_form;

}

sub post_transaction {

  # check if there is something in source and date
  #$form->isblank("source", $locale->text('Source missing!'));
  #$form->isblank("transdate", $locale->text('Transaction Date missing!'));





  $rc = dataentry3->post_transaction(\%myconfig, \%$form);

  if ($rc == -1) {
    $form->error($locale->text("Cannot have a value in both Debit and Credit!"));
  }

  if ($rc == -2) {
    $form->error($locale->text("Debit and Credit out of balance!"));
  }

  $form->isposted($rc);

}

sub delete_transaction {

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  map { $form->{$_} =~ s/"/&quot;/g } qw(source description chart);

  foreach $key (keys %$form) {
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>|.$locale->text('Confirm!').qq|</font></h2>

<h4>|.$locale->text('Are you sure you want to delete Transaction').qq| $form->{source}</h4>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes Delete Transaction').qq|">
</form>
|;

}

sub yes_delete_transaction {

  $form->isdeleted(dataentry3->delete_transaction(\%myconfig, \%$form));

}
