
#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Genereal Ledger
#
#======================================================================


use SL::receipt;
require "format/print_receipt.pl";
use SL::IS;

1;
# end of main


# this is for our long dates
# $locale->text('January')
# $locale->text('February')
# $locale->text('March')
# $locale->text('April')
# $locale->text('May ')
# $locale->text('June')
# $locale->text('July')
# $locale->text('August')
# $locale->text('September')
# $locale->text('October')
# $locale->text('November')
# $locale->text('December')

# this is for our short month
# $locale->text('Jan')
# $locale->text('Feb')
# $locale->text('Mar')
# $locale->text('Apr')
# $locale->text('May')
# $locale->text('Jun')
# $locale->text('Jul')
# $locale->text('Aug')
# $locale->text('Sep')
# $locale->text('Oct')
# $locale->text('Nov')
# $locale->text('Dec')



sub generate_report {
 &{$form->{nextsub}}(\%myconfig, \%$form);
}





sub add {

  $form->{title} = "Add";

  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&login=$form->{login}&password=$form->{password}";

 # $form->create_links("AR", \%myconfig, "customer");
#  $taxincluded = $form->{taxincluded};
 $form->create_links("AR", \%myconfig, "customer");
   receipt->get_chart(\%myconfig, \%$form);

  # build the popup menus

  # currencies
  @curr = split /:/, $form->{currencies};
  chomp $curr[0];
  $form->{defaultcurrency} = $curr[0];
 $form->{currency} = $curr[0];

  map { $form->{selectcurrency} .= "<option>$_\n" } @curr;

 # forex
  $form->{forex} = $form->{exchangerate};

 if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }
  # we use this only to set a default date
  receipt->transaction(\%myconfig, \%$form);

  
if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}

 # $form->{rowcount} = 1;


 $form->{sort}="invnumber";
   
   receipt->last_invoice(\%myconfig, \%$form);
   $form->{orid}=$form->{lastinvnumber};
   $form->{orid}++;

   $form->{nextfocus}="transtype";
  &update_form;
}



sub update_form {

  @a = ();
  $count = 0;
  @flds = (qw( no  ar_id invoice  status ));
  $fulltotal=0;
  for $i ( 1 .. $form->{rowcount}) {
    map { delete $form->{"${_}_$i"} } @flds;
 #   delete $form->{"ar_id_$i"}
  }
  
  undef $form->{GL};
    receipt->get_ar_list(\%myconfig, \%$form);

   $i = 1;
   foreach $ref (@{ $form->{GL} }) {
    $form->{"ar_id_$i"} = $ref->{id};
    $form->{"invoice_$i"} = $ref->{invnumber};
   $form->{"amount1_$i"} = $ref->{amount};
 
  #  &form_row($i++);
  $i++;
  }
 # $i++;
   $form->{rowcount}=$i;
   
  
  for $i (1 .. $form->{rowcount}) {
 $form->{"total_$i"} = $form->parse_amount($myconfig, $form->{"total_$i"});
   unless ($form->{"ar_id_$i"} eq "") {
      # take accno apart
     # ($form->{"invoice_$i"}) = split(/--/, $form->{"accno_$i"});
    # $form->dberror($query);
      if($form->{"total_$i"} eq ""){
       $form->{"ar_id1"}=$form->{"ar_id_$i"};
      	receipt->get_AR(\%myconfig, \%$form);
	$form->{"total_$i"} = $form->parse_amount($myconfig, $form->{"total_$i"});
	$form->{"amount1_$i"} = $form->{"amount1"};
	$form->{"due_$i"} = $form->{"amount1"}-$form->{"paid"};
	$form->{"ar_date_$i"} = $form->{"ar_date"};
	$form->{"description_$i"} = $form->{"description"};
	$form->{"ar_id_$i"} = $form->{"ar_id"};
	$form->{"status_$i"} = "Full Payment";

#$form->dberror($form->{"ar_date_$i"});

	if($form->{"invnumber"} eq ""){
		$form->{"invoice_$i"}="";
	$form->{"ar_date_$i"} ="";
	$form->{"description_$i"} = "";
		$form->{"total_$i"}="";
		$form->{"status_$i"}="";
		$form->{"ar_id_$i"} ="";
	}
      }else{
       $form->{"ar_id1"}=$form->{"ar_id_$i"};
      	receipt->get_AR(\%myconfig, \%$form);
	#$form->{"total_$i"} = $form->{"total"};
	#$form->{"ar_id_$i"} = $form->{"ar_id"};

	if($form->{"invnumber"} eq ""){
		$form->{"invoice_$i"}="";
		$form->{"total_$i"}="";
		$form->{"status_$i"}="";
		$form->{"ar_id_$i"} ="";
	$form->{"ar_date_$i"} = "";
	$form->{"description_$i"} = "";

	}
	else{
		$amount1 =$form->{"amount1"};
		$paid =$form->{"paid"};
		$total=$form->parse_amount($myconfig, $form->{"total_$i"});
		$form->{"ar_date_$i"} = $form->{"ar_date"};
		$form->{"ar_id_$i"} = $form->{"ar_id"};
		$form->{"description_$i"} = $form->{"description"};
		$all = $amount1-$paid-$total;
		$form->{"due_$i"}=$all;
	$form->{"amount1_$i"} = $form->{"amount1"};
		if($all == 0){
				$form->{"status_$i"} = "Full Payment ";
		}else{
				$form->{"status_$i"} = "Part Payment ";
		}
	}
      }

      $fulltotal +=$form->parse_amount($myconfig, $form->{"total_$i"});

      push @a, {};
      $j = $#a;
      
      map { $a[$j]->{$_} = $form->{"${_}_$i"} } @flds;
      $count++;
    }
  }

  for $i (1 .. $count) {
    $j = $i - 1;
    map { $form->{"${_}_$i"} = $a[$j]->{$_} } @flds;
  }

  for $i ($count + 1 .. $form->{rowcount}) {
    map { delete $form->{"${_}_$i"} } @flds;
  }

  $form->{rowcount} = $count;
$form->{customer_key}=$form->{customer};

##eware change
#if(!$form->{amount}){
#	$form->{amount}=$fulltotal
#}
#if(!$form->{source}){
#	$form->{source}=$form->{orid};
#}
	  $check = new IS $myconfig{countrycode};
  $check->init;
  $form->{text_amount} = $check->num2text($form->{amount});
 # $form->dberror($form->{text_amount});
 if(   $form->{decimal}>0){
	 $form->{text_amount} .= " And ". $check->num2text($form->{decimal})." Cents";
 }
  $form->{text_amount} .=" Only";
  ###eware change end

  
  &display_form;
  
}


sub display_form {

  &form_header;

 # $form->{rowcount}++;
  for $i (1 .. $form->{rowcount}) {
    &form_row($i);
  }
 $fulltotal = $form->format_amount(\%myconfig, $fulltotal, 2, "0");

 print qq|<tr class=listsubtotal bgcolor=333366>

  <td></td>
  <td></td>
  <td align=right><input type=hidden name=fulltotal value=$fulltotal>$fulltotal</td>
  <td></td>
  <td></td>
 <td></td>

</tr>


|;
  &form_footer;

}



sub print {

  &form_header_print;

  $form->{rowcount}++;
  $form->{rownumber}=0;
  for $i (1 .. $form->{rowcount}) {
    if($form->{"total_$i"}){
   $form->{rownumber}++;
   &form_row_print($i);
    }
  }
 $form->{amount} = $form->format_amount(\%myconfig, $form->{amount}, 2, "&nbsp;");
 print qq|<tr >

  <td><hr noshade size=2> &nbsp;</td>
   <td><hr noshade size=2> <b>Total</b></td>
  <td align=right><hr noshade size=2><b><input type=hidden name=fulltotal value=$fulltotal>$form->{fulltotal}</b></td>
 <td><hr noshade size=2> &nbsp;</td>

</tr>

<tr >

  <td colspan=4 align=right> <br><br><b>Computer generated receipt <br> No Signature required</b></td>

</tr>
|;
  &form_footer_print;

}

sub form_row {
  my $i = shift;

$form->{"total_$i"} = $form->format_amount(\%myconfig, $form->{"total_$i"}, 2);

$form->{"amount1_$i"} = $form->format_amount(\%myconfig, $form->{"amount1_$i"}, 2);
$form->{"due_$i"} = $form->format_amount(\%myconfig, $form->{"due_$i"}, 2,"0.00");

  print qq|<tr>
  <td>$i) $form->{"ar_date_$i"} <input type=hidden name=ar_date_$i value=$form->{"ar_date_$i"}>
  <input type=hidden name=ar_id_$i value=$form->{"ar_id_$i"}>
  <input type=hidden name=description_$i value='$form->{"description_$i"}'>
  </td>
  <td><input type=hidden name="invoice_$i" size=10 value="$form->{"invoice_$i"}">$form->{"invoice_$i"}</td>
  <td align =right><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="total_$i" size=10 value="$form->{"total_$i"}"></td>
  <td align =right>$form->{"amount1_$i"}</td>
  <td align =right>$form->{"due_$i"}</td>
  <td align=center><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="status_$i" type=hidden value='$form->{"status_$i"}'>$form->{"status_$i"}</td>

</tr>
<input type=hidden name=rowcount value=$i>
<input type=hidden name=amount1_$i value=$form->{"amount1_$i"}>
<input type=hidden name=due_$i value=$form->{"due_$i"}>

|;


}


sub form_header {
   my $chart;
   my $customer;

    receipt->get_chart(\%myconfig, \%$form);

  #EXCHANGE RATE	
  foreach $item (qw( currency)) {
    $form->{"select$item"} =~ s/ selected//;
    $form->{"select$item"} =~ s/option>\Q$form->{$item}\E/option selected>$form->{$item}/;
  }

  $form->{exchangerate} = $form->format_amount(\%myconfig, $form->{exchangerate});

  $exchangerate = qq|&nbsp;|;
  if ($form->{currency} ne $form->{defaultcurrency}) {
    if ($form->{forex}) {
      $exchangerate = qq|<input type=hidden name=exchangerate value=$form->{exchangerate}>$form->{exchangerate}|;
    } else {
      $exchangerate = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=exchangerate size=10 value=$form->{exchangerate}>|;
    }
  }
  $exchangerate .= qq|
<input type=hidden name=forex value=$form->{forex}>
|;


  foreach $item (split /\n/, $form->{chart}) {


    ($key, $value) = split /--/, $item;
  ($key1, $value1) = split /--/, $form->{"chart_key"};

	#if($form->{"accno1_$i"}){
	#	$form->{"accno_$i"}=$form->{"accno1_$i"} ;
	#}

		if ($key eq $key1) {
      			$chart .= "<option selected>$key--$value\n";

   		} else {



			if($form->{"chart"} eq ''){
					$chart .= "<option>$key--$value\n";

			}else{
#				if ($key =~ /^$form->{"accno1_$i"}/){
					$chart .= "<option>$key--$value\n";
				}
#			}

		}


  }

   
 foreach $item (split /\n/, $form->{"customer"}) {


    ($key, $value) = split /--/, $item;
   ($key1, $value1) = split /--/, $form->{"customer_key"};



		if ($key eq $key1) {
      			$customer .= "<option selected>$key--$value\n";

   		} else {



			if($form->{"customer"} eq ''){
					$customer .= "<option>$key--$value\n";

			}else{
#				if ($key =~ /^$form->{"customer_key"}/){
				$customer .= "<option>$key--$value\n";
#				}
			}

		}


  }


  $title = $form->{title};
  $form->{title} = $locale->text("$title Official Receipt");

# $locale->text('Add General Ledger Transaction')
# $locale->text('Edit General Ledger Transaction')

  map { $form->{$_} =~ s/"/&quot;/g } qw(source description chart);

  #if (($rows = $form->numtextrows($form->{description}, 50)) > 1) {
 #   $description = qq|<textarea name=description rows=$rows cols=50 wrap=soft>$form->{description}</textarea>|;
 # } else {
#    $description = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=description size=50 value="$form->{description}">|;
 # }


  $colspan = 6;


  $form->header;

  print qq|
  
<script>
<!--

function stb(){
        document.myform.$form->{nextfocus}.focus();
}


// -->
</script>


<body bgcolor=ffffff onLoad=stb()>

<form  name=myform method=post action=$form->{script}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=id type=hidden value=$form->{id}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=chart type=hidden value="$form->{chart}">
<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=title value="$title">
<input type=hidden name=sort value="invnumber">
<input type=hidden name=nextfocus value=$form->{nextfocus}>
<input type=hidden name=keys >

<table border=1 width=100%>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>
<table border=0>
<tr>

  <th align=right>|.$locale->text('Trans No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transtype size=4 value="$form->{transtype}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=batch size=6 value="$form->{batch}">-<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transno  size=4 value="$form->{transno}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subtransno size=2 value="$form->{subtransno}"></td>

</tr>
<tr>
  <th align=right>|.$locale->text('Customer Acc NO.').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=customer >$customer</select></td>
  <th align=right>|.$locale->text('Date').qq| ($myconfig{dateformat})</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transdate size=11 value=$form->{transdate}>
             <link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['myform'].transdate.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
    
  </td>
  
  </tr>

<tr>

  <th align=right>|.$locale->text('OR No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=orid value="$form->{orid}"></td> 
  
  <th>Last Receipt No : $form->{lastinvnumber}<input  name=lastinvnumber  type=hidden value="$form->{lastinvnumber}"></th>


</tr>

<tr>
  <th align=right>|.$locale->text('Cheque No.').qq|</th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=source value="$form->{source}"></td>

  <th align=right>|.$locale->text('Payment Acc No.').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=chart_key>$chart</select></td>
</tr>

<tr>

  <th align=right>|.$locale->text('Amount').qq|</th>
  <td ><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=amount value="$form->{amount}"></td>

</tr>
<tr>

  <th align=right>|.$locale->text('Currency').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=currency>$form->{selectcurrency}</select></td>
  <th align=right>|.$locale->text('Exchangerate').qq|</th>
  <td>$exchangerate</td>

  <input type=hidden name=selectcurrency value="$form->{selectcurrency}">
  <input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
  <input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
  <input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>
</tr>

</table>
</td></tr>

<tr class=listheading bgcolor=336666>

  <th><font color=ffffff>|.$locale->text('Date').qq|</th>
  <th><font color=ffffff>|.$locale->text('Invoice').qq|</th>
  <th><font color=ffffff>|.$locale->text('Total').qq|</th>
  <th><font color=ffffff>|.$locale->text('Amount').qq|</th>
  <th><font color=ffffff>|.$locale->text('Due').qq|</th>
  <th><font color=ffffff>|.$locale->text('Status').qq|</th>

</tr>
|;

}


sub form_footer {

  print qq|

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<input type=hidden name=action value='Update Form'>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

</table>

<br>
|;

  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);

  if ($form->{id}) {
    print qq|
<input class=submit type=submit name=action value="|.$locale->text('Print').qq|">
|;

    if (!$form->{revtrans}) {
      if (!$form->{locked}) {
	print qq|
	
	<input class=submit type=submit name=action value="|.$locale->text('Delete Transaction').qq|">
|;
      }
    }

    if ($transdate > $closedto) {
      print qq|
      
|;
    }

  } else {
    if ($transdate > $closedto) {
      print qq|<input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">
 <input class=submit type=submit name=action value="|.$locale->text('Print').qq|">
     <input class=submit type=submit name=action value="|.$locale->text('Post Transaction').qq|">|;
    }
  }

  print "</form>

</body>
</html>
";

}



sub post_transaction {

  # check if there is something in source and date
   $form->isblank("orid", $locale->text('Receipt Number missing!'));
 $form->isblank("source", $locale->text('Cheque Number missing!'));
  $form->isblank("transdate", $locale->text('Transaction Date missing!'));
  $form->isblank("amount", $locale->text('Amount missing!'));

  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  
#$form->error($fulltotal);
$fulltotal =$form->parse_amount($myconfig, $form->{fulltotal});
$amounttotal =$form->parse_amount($myconfig, $form->{amount});

  if ($fulltotal ne $amounttotal) {
    $form->error($locale->text("Amount and the total is different!"));
  }

 # this is just for the wise guys
  $form->error($locale->text('Cannot post transaction for a closed period!')) if ($transdate <= $closedto);

  $rc = receipt->add(\%myconfig, \%$form);

    if ($rc == -1) {
    $form->error($locale->text("Amount and the total is different!"));
  }

  if ($rc == -2) {
    $form->error($locale->text("Debit and credit out of balance!"));
  }
	$form->header;

	print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

	print qq|
<h2><font color=blue>|.$locale->text('Confirm!').qq|</font></h2>

<h4>|.$locale->text('Do you want to create another Receipt?').qq|</h4>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes New Receipt').qq|">

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

</form>
|;
  #$form->isposted($rc);

}


sub yes_new_receipt {

 &add();

}
####the below function is tobe deleted
sub search {
   

  $form->{title} = $locale->text('Official Receipt')." ".$locale->text('Reports');

  $form->header;
 $form->all_vc(\%myconfig, "customer");

  $selection = "<option selected>" . $locale->text('All Customers') . "\n";

  foreach $ref (@{ $form->{all_customer} }) {
    $selection .= "<option>$ref->{name}--$ref->{id}\n";
  }


  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script} name=myform>

<input type=hidden name=sort value=id>
<input type=hidden name=add value=1>
<input type=hidden name=nextfocus value=$form->{nextfocus}>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>

<tr>
<th align=right>|.$locale->text('Customer').qq|</th>
<td colspan=3><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=customer>$selection</select></td>
</tr>


<tr>

  <th align=right>|.$locale->text('O/R No.').qq| </th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=orid size=11 value=$form->{orid}></td>

</tr>


<tr>

  <th align=right>|.$locale->text('Source.').qq| </th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=source size=11></td>

</tr>

<tr>

<th align=right>|.$locale->text('From').qq|<br></th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=datefrom size=11 title=($myconfig{dateformat})>  <link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['search'].datefrom.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>

</td>
<th align=right>|.$locale->text('To').qq|</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=dateto size=11 title=($myconfig{dateformat})>  

   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar2Callback(date, month, year)
        {
            document.forms['search'].dateto.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar2 = new dynCalendar('calendar2', 'calendar2Callback', 'javascript/images/');
    //-->
    </script>

</td>

</tr>
<tr>
<td colspan=3>
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_option" class=checkbox type=checkbox value=Y  $form->{l_option}>&nbsp;|.$locale->text('Show Search Criteria').qq|
</td>
</tr>
<tr>

  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>

    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_id" class=checkbox type=checkbox value=Y >&nbsp;|.$locale->text('ID').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_transno" class=checkbox type=checkbox value=Y >&nbsp;|.$locale->text('Transno').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_transdate" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Date').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_orid" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('O/R No').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_customer" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Customer').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_source" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Source').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_curr" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Currency').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_amount" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Amount').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_employee" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Employee').qq|

    </td>

  </tr>


</table>
</td>

</tr>
</table>

<input type=hidden name=nextsub value=searchall>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Generate Report').qq|">
</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

  .qq|

</body>
</html>
|;
}

sub search2 {
    receipt->get_chart(\%myconfig, \%$form);
  foreach $item (split /\n/, $form->{chart}) {


    ($key, $value) = split /--/, $item;
  ($key1, $value1) = split /--/, $form->{"chart_key"};

	#if($form->{"accno1_$i"}){
	#	$form->{"accno_$i"}=$form->{"accno1_$i"} ;
	#}

		if ($key == $key1) {
      			$chart .= "<option selected>$key--$value\n";

   		} else {



			if($form->{"chart"} eq ''){
					$chart .= "<option>$key--$value\n";

			}else{
#				if ($key =~ /^$form->{"accno1_$i"}/){
					$chart .= "<option>$key--$value\n";
				}
#			}

		}


  }

  $form->{title} = $locale->text('Official Receipt')." ".$locale->text('Reports');

  $form->header;
 $form->all_vc(\%myconfig, "customer");

  $selection = "<option selected>" . $locale->text('All Customers') . "\n";

  foreach $ref (@{ $form->{all_customer} }) {
    $selection .= "<option>$ref->{name}--$ref->{id}\n";
  }


  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script} name=myform>

<input type=hidden name=sort value=orid>
<input type=hidden name=add value=1>
<input type=hidden name=nextfocus value=$form->{nextfocus}>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>

<tr>
<th align=right>|.$locale->text('Customer').qq|</th>
<td colspan=3><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=customer>$selection</select></td>
</tr>


<tr>

  <th align=right>|.$locale->text('O/R No.').qq| </th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=orid size=11 value=$form->{orid}></td>

</tr>


<tr>

  <th align=right>|.$locale->text('Source.').qq| </th>
  <td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=source size=11></td>

</tr>
<tr>
  <th align=right>|.$locale->text('Payment Acc No.').qq|</th>
  <td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=chart_key><option>--All Payment-- $chart</select></td>
</tr>

<tr>

<th align=right>|.$locale->text('From').qq|<br></th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=datefrom size=11 title=($myconfig{dateformat})><link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['search'].datefrom.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
    </td>
<th align=right>|.$locale->text('To').qq|</th>
<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=dateto size=11 title=($myconfig{dateformat})>
  <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar2Callback(date, month, year)
        {
            document.forms['search'].dateto.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar2 = new dynCalendar('calendar2', 'calendar2Callback', 'javascript/images/');
    //-->
    </script></td>

</tr>
<td colspan=3>
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_option" class=checkbox type=checkbox value=Y  $form->{l_option}>&nbsp;|.$locale->text('Show Search Criteria').qq|
</td>
<tr>

  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>

    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_id" class=checkbox type=checkbox value=Y >&nbsp;|.$locale->text('ID').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_transno" class=checkbox type=checkbox value=Y >&nbsp;|.$locale->text('Transno').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_transdate" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Date').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_orid" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('O/R No').qq|
   <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_customernumber" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Cust. No.').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_customer" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Customer').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_source" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Source').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_curr" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Currency').qq|
     <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_payacc" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Payment Account').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_paydesc" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Payment Description').qq|
   <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_invnumber" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Invoice Number').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_amount" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Amount').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_employee" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Employee').qq|
    <input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="l_subtotal" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Subtotal').qq|

    </td>

  </tr>


</table>
</td>

</tr>
</table>

<input type=hidden name=nextsub value=searchall2>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Generate Report').qq|">
</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

  .qq|

</body>
</html>
|;
}



sub searchall {

     $mouseaction[0]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow0';\"";
    $mouseaction[1]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow1';\"";
    
  $callback = "$form->{script}?action=searchall&path=$form->{path}&login=$form->{login}&password=$form->{password}";


  $form->{title} = $locale->text('List of Official Receipt');

  unless ($form->{category} eq 'X') {
    $form->{title} .= " : ".$locale->text($acctype{$form->{category}});
  }

  ($customer, $form->{customer_id}) = split(/--/, $form->{customer});
  if ($form->{customer_id}) {
    $callback .= "&customer=$form->{customer}";
    $option .= $customer;
  }

  
  if ($form->{orid}) {
    $callback .= "&orid=$form->{orid}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Receipt No.')." : $form->{orid}";
  }
  if ($form->{source}) {
    $callback .= "&source=$form->{source}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Ref No.')." : $form->{source} ";
  }
  
    if ($form->{datefrom}) {
    $callback .= "&datefrom=$form->{datefrom}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('From')." ".$locale->date(\%myconfig, $form->{datefrom}, 1);
  }
  if ($form->{dateto}) {
    $callback .= "&dateto=$form->{dateto}";
    if ($form->{datefrom}) {
      $option .= " ";
    } else {
      $option .= "\n<br>" if $option;
    }
    $option .= $locale->text('To')." ".$locale->date(\%myconfig, $form->{dateto}, 1);
  }

  
 receipt->list_transactions(\%myconfig, \%$form);

 @columns = $form->sort_columns(qw(id transno transdate orid  customer source curr amount employee ));
  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }
  @columns = $form->sort_columns(orid );


  $href = "$callback&sort=$form->{sort}";        # needed for accno


  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }

  $callback .= "&category=$form->{category}";
  $href .= "&category=$form->{category}";

  $column_header{id} = "<th><a class=listheading href=$callback&sort=id><font color=ffffff>".$locale->text('ID')."</a></th>";
  $column_header{transno} = "<th><a class=listheading href=$callback&sort=transtype,batch,transno,subtransno><font color=ffffff>".$locale->text('Trans. No.')."</a></th>";
  $column_header{transdate} = "<th><a class=listheading href=$callback&sort=transdate><font color=ffffff>".$locale->text('Date')."</a></th>";
  $column_header{orid} = "<th><a class=listheading href=$callback&sort=orid><font color=ffffff>".$locale->text('O/R No')."</a></th>";
  #$column_header{customer} = "<th><a class=listheading href=$callback&sort=customer><font color=ffffff>".$locale->text('Customer')."</a></th>";
  $column_header{source} = "<th><a class=listheading href=$callback&sort=source><font color=ffffff>".$locale->text('Ref No.')."</a></th>";
 $column_header{customer} = "<th><font color=ffffff>".$locale->text('Customer')."</th>";
 $column_header{curr} = "<th><font color=ffffff>".$locale->text('Currency')."</th>";
 $column_header{amount} = "<th><font color=ffffff>".$locale->text('Amount')."</th>";
  $column_header{employee} = "<th><a class=listheading href=$callback&sort=employee><font color=ffffff>".$locale->text('Employee')."</a></th>";
  $colspan = $#column_index + 1;

  $form->header;
	    $option ='' if(!$form->{l_option})  ;

  print  qq|
 <body bgcolor=ffffff>

<table border=0 width=100%>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>$option</td></tr>

<tr class=listheading bgcolor=336666>
|;

map { print  "$column_header{$_}\n" } @column_index;

print  "</tr>";

  # add sort to callback
  $callback = $form->escape($callback . "&sort=$form->{sort}");

  # initial item for subtotals
  if (@{ $form->{GL} }) {
    $sameitem = $form->{GL}->[0]->{$form->{sort}};
  }

  foreach $ref (@{ $form->{report} }) {
    # if item ne sort print subtotal
    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ref->{$form->{sort}}) {
	&gl_subtotal;
      }
    }


    $customer =$ref->{customernumber}."--".$ref->{customer_id};

    $column_data{id} = "<td><a href=receipt.pl?action=edit&sort=transdate&id=$ref->{id}&source=".$form->escape($ref->{source})."&customerno=".$form->escape($customer)."&l_transdate=Y&l_invnumber=Y&l_amount=Y&l_subtotal1=Y&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{id}</a></td>";
    $column_data{orid} = "<td><a href=receipt.pl?action=edit&sort=transdate&id=$ref->{id}&sourceno=".$form->escape($ref->{source})."&customerno=".$form->escape($customer)."&l_transdate=Y&l_invnumber=Y&l_amount=Y&l_subtotal1=Y&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{orid}</a></td>";
  # #  $column_data{customer} = "<td>$ref->{customer}</td>";
    $column_data{transno} = "<td>$ref->{transtype}-$ref->{batch}-$ref->{transno}$ref->{subtransno}</td>";
    $column_data{transdate} = "<td>$ref->{transdate}</td>";
    $column_data{source} = "<td>$ref->{source}</td>";

      $column_data{customer} = "<td>$ref->{name}</td>";
    $column_data{curr} = "<td>$ref->{curr}</td>";
     $column_data{amount} = "<td>$ref->{amount}</td>";
   $column_data{employee} = "<td>$ref->{employee}</td>";

    $i++; $i %= 2;
    print  "<tr class=listrow$i $mouseaction[$i] >";
    map { print "$column_data{$_}\n" } @column_index;
    print  "</tr>";

  }




  map { $column_data{$_} = "<td>&nbsp;</td>" } @column_index;


  print  qq|
<tr class=listtotal bgcolor=000000>|;

  map { print  "$column_data{$_}\n" } @column_index;

  print  qq|</tr>
 </table>

<p>
|
.$locale->text('Click on "Receipt" to edit Transaction')
.qq|
<br>


</body>
</html>
|;

}

sub searchall2 {
    $mouseaction[0]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow0';\"";
    $mouseaction[1]=" onmouseover=\"this.className = 'listover';\" onmouseout=\"this.className = 'listrow1';\"";
    
 
  $callback = "$form->{script}?action=searchall2&path=$form->{path}&login=$form->{login}&password=$form->{password}";


  $form->{title} = $locale->text('List of Official Receipt');

  unless ($form->{category} eq 'X') {
    $form->{title} .= " : ".$locale->text($acctype{$form->{category}});
  }

  ($customer, $form->{customer_id}) = split(/--/, $form->{customer});
  if ($form->{customer_id}) {
    $callback .= "&customer=$form->{customer}";
    $option .= $customer;
  }
 ( $form->{payment_id},$payment) = split(/--/, $form->{chart_key});
  if ($form->{payment_id}) {
    $callback .= "&chart_key=$form->{chart_key}";
    $option .= $payment;
  }
  
  
  if ($form->{orid}) {
    $callback .= "&orid=$form->{orid}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Receipt No.')." : $form->{orid} ";
  }
  if ($form->{source}) {
    $callback .= "&source=$form->{source}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Ref No.')." : $form->{source} ";
  }
  
    if ($form->{datefrom}) {
    $callback .= "&datefrom=$form->{datefrom}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('From')." ".$locale->date(\%myconfig, $form->{datefrom}, 1);
  }
  if ($form->{dateto}) {
    $callback .= "&dateto=$form->{dateto}";
    if ($form->{datefrom}) {
      $option .= " ";
    } else {
      $option .= "\n<br>" if $option;
    }
    $option .= $locale->text('To')." ".$locale->date(\%myconfig, $form->{dateto}, 1);
  }

  
 receipt->list_transactions2(\%myconfig, \%$form);

 @columns = $form->sort_columns(qw(id transno transdate orid  customernumber customer source invnumber payacc paydesc curr amount employee ));
  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }
  @columns = $form->sort_columns(orid );


  $href = "$callback&sort=$form->{sort}";        # needed for accno


  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }

  $callback .= "&category=$form->{category}";
  $href .= "&category=$form->{category}";

  $column_header{id} = "<th><a class=listheading href=$callback&sort=id><font color=ffffff>".$locale->text('ID')."</a></th>";
  $column_header{transno} = "<th><a class=listheading href=$callback&sort=transdate><font color=ffffff>".$locale->text('Trans. No.')."</a></th>";
  $column_header{transdate} = "<th><a class=listheading href=$callback&sort=transdate><font color=ffffff>".$locale->text('Date')."</a></th>";
  $column_header{orid} = "<th><a class=listheading href=$callback&sort=orid><font color=ffffff>".$locale->text('O/R No')."</a></th>";
  #$column_header{customer} = "<th><a class=listheading href=$callback&sort=customer><font color=ffffff>".$locale->text('Customer')."</a></th>";
  $column_header{source} = "<th><a class=listheading href=$callback&sort=source><font color=ffffff>".$locale->text('Source')."</a></th>";
 $column_header{invnumber} = "<th><font color=ffffff>".$locale->text('Invoice')."</th>";
 $column_header{payacc} = "<th><font color=ffffff><a class=listheading href=$callback&sort=chart_id>".$locale->text('P/Acc')."</th>";
 $column_header{paydesc} = "<th><font color=ffffff>".$locale->text('P/Desc')."</th>";
 $column_header{customernumber} = "<th><a class=listheading href=$callback&sort=customernumber><font color=ffffff>".$locale->text('Cust no.')."</a></th>";
 $column_header{customer} = "<th><font color=ffffff>".$locale->text('Customer')."</th>";
 $column_header{curr} = "<th><font color=ffffff>".$locale->text('Currency')."</th>";
 $column_header{amount} = "<th><font color=ffffff>".$locale->text('Amount')."</th>";
  $column_header{employee} = "<th><a class=listheading href=$callback&sort=employee><font color=ffffff>".$locale->text('Employee')."</a></th>";
  $colspan = $#column_index + 1;

  $form->header;
	    $option ='' if(!$form->{l_option})  ;

  print  qq|
 <body bgcolor=ffffff>

<table border=0 width=100%>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>$option</td></tr>

<tr class=listheading bgcolor=336666>
|;

map { print  "$column_header{$_}\n" } @column_index;



print  "</tr>";

  # add sort to callback
  $callback = $form->escape($callback . "&sort=$form->{sort}");

  # initial item for subtotals
  if (@{ $form->{report} }) {
    $sameitem = $form->{report}->[0]->{$form->{sort}};
  }

  foreach $ref (@{ $form->{report} }) {
    # if item ne sort print subtotal
    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ref->{$form->{sort}}) {
	&gl_subtotal;
      }
    }

   $subtotalamount += $ref->{amount};
    $totalamount += $ref->{amount};
  $ref->{amount} = $form->format_amount(\%myconfig, $ref->{amount}, 2, "&nbsp;");
 
    $customer =$ref->{customernumber}."--".$ref->{customer_id};

    $column_data{id} = "<td><a href=receipt.pl?action=edit&sort=transdate&id=$ref->{id}&source=".$form->escape($ref->{source})."&customerno=".$form->escape($customer)."&l_transdate=Y&l_invnumber=Y&l_amount=Y&l_subtotal1=Y&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{id}</a></td>";
    $column_data{orid} = "<td><a href=receipt.pl?action=edit&sort=transdate&id=$ref->{id}&sourceno=".$form->escape($ref->{source})."&customerno=".$form->escape($customer)."&l_transdate=Y&l_invnumber=Y&l_amount=Y&l_subtotal1=Y&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{orid}</a></td>";
  # #  $column_data{customer} = "<td>$ref->{customer}</td>";
    $column_data{transno} = "<td>$ref->{transtype}-$ref->{batch}-$ref->{transno}$ref->{subtransno}</td>";
    $column_data{transdate} = "<td>$ref->{transdate}</td>";
    $column_data{source} = "<td>$ref->{source}</td>";
     $column_data{customernumber} = "<td>$ref->{customernumber}</td>";
     $column_data{invnumber} = "<td>$ref->{invnumber}</td>";
    $column_data{payacc} = "<td>$ref->{chart_id}</td>";
    $column_data{paydesc} = "<td>$ref->{description}</td>";

     $column_data{customer} = "<td>$ref->{name}</td>";
    $column_data{curr} = "<td>$ref->{curr}</td>";
     $column_data{amount} = "<td align=right>$ref->{amount}</td>";
   $column_data{employee} = "<td>$ref->{employee}</td>";

    $i++; $i %= 2;
    print  "<tr class=listrow$i $mouseaction[$i] >";
    map { print "$column_data{$_}\n" } @column_index;
    print  "</tr>";

  }


  &gl_subtotal if ($form->{l_subtotal} eq 'Y');


  map { $column_data{$_} = "<td>&nbsp;</td>" } @column_index;
  $column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $totalamount, 2, "&nbsp;")."$line</th>";


  print  qq|
<tr class=listtotal bgcolor=000000>|;

  map { print  "$column_data{$_}\n" } @column_index;

  print  qq|</tr>
 </table>

<p>
|
.$locale->text('Click on "Receipt" to edit Transaction')
.qq|
<br>


</body>
</html>
|;

}

sub gl_subtotal {

   $subtotalamount = $form->format_amount(\%myconfig, $subtotalamount, 2, "&nbsp;");

  map { $column_data{$_} = "<td class=listsubtotal >&nbsp;</td>" } qw( id transno transdate orid  customernumber customer source invnumber payacc paydesc curr employee);
  $column_data{amount} = "<th align=right $listprint >$line$subtotalamount$line</font></td>";


  print "<tr class=listsubtotal bgcolor=333366>";
    if($form->{l_sr}){

    	print "<td class=listsubtotal >&nbsp;</td>";
    }
 map { print "$column_data{$_}\n" } @column_index;
  print "</tr>";

  $subtotalamount = 0;

  $sameitem = $ref->{$form->{sort}};

}

sub delete_transaction {

  $form->{title} = $locale->text('Confirm!');

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  foreach $key (keys %$form) {
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>$form->{title}</font></h2>

<h4>|.$locale->text('Are you sure you want to delete Transaction').qq| $form->{source}</h4>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes Delete Transaction').qq|">
</form>

</body>
</html>
|;

}


sub yes_delete_transaction {
receipt->delete_receipt(\%myconfig, \%$form);
  $form->isdeleted(receipt->delete_receipt(\%myconfig, \%$form));

}

sub edit {

  receipt->transaction(\%myconfig, \%$form);
 
 $form->create_links("AR", \%myconfig, "customer");

  # build the popup menus

  # currencies
  @curr = split /:/, $form->{currencies};
  chomp $curr[0];
  $form->{defaultcurrency} = $curr[0];
  #$form->{currency} = $curr[0];

  map { $form->{selectcurrency} .= "<option>$_\n" } @curr;

  $form->{locked} = ($form->datetonum($form->{transdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));

  $form->{title} = "Edit";
   $form->{nextfocus}="transtype";

  &form_header;

  $i = 1;
  foreach $ref (@{ $form->{GL} }) {
    $form->{"total_$i"} = $ref->{amount};
    $form->{"ar_date_$i"} = $ref->{ar_date};
    $form->{"status_$i"} = $ref->{status};
    $form->{"ar_id_$i"} = $ref->{ar_chart_id};
    $form->{"invoice_$i"} = $ref->{invnumber};
    $form->{"amount1_$i"} = $ref->{amount1};
    $form->{"due_$i"} = $ref->{due};
    $fulltotal+=$form->{"total_$i"};
    &form_row($i++);
  }

#  &form_row($i);
 $fulltotal = $form->format_amount(\%myconfig, $fulltotal, 2, "0");

 print qq|<tr class=listsubtotal bgcolor=333366>

  <td></td>
  <td></td>
  <td align=right><input type=hidden name=fulltotal value=$fulltotal>$fulltotal</td>
  <td></td>
  <td></td>
 <td></td>

</tr>


|;
  &form_footer;
}
