package dataentry3;

sub transaction{
  my ($self, $myconfig, $form) = @_;

  my ($query, $sth);

  # connect to database
  my $dbh = $form->dbconnect($myconfig);

if ($form->{id}) {
    $query = "SELECT closedto, revtrans
              FROM defaults";
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    ($form->{closedto}, $form->{revtrans}) = $sth->fetchrow_array;
    $sth->finish;
    
    
    
    $query = "SELECT transtype, batch
              FROM ou
	      WHERE ou.id = $form->{id}";
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    ($form->{transtype},  $form->{batch}) = $sth->fetchrow_array;
    $sth->finish;



    # retrieve individual rows
    $query = "SELECT chart.accno, chart.description as accdesc,amount,source,ou_trans.description,transno,subtransno,transdate
	      FROM ou_trans, chart
	      WHERE ou_trans.chart_id = chart.id
	      AND ou_trans.id = $form->{id} and source != ''
	      ORDER BY transno,accno";
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
      push @{ $form->{dataentry3} }, $ref;
    }
    

  } else {
    $query = "SELECT current_date AS transdate, closedto, revtrans
              FROM defaults";
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    ($form->{transdate}, $form->{closedto}, $form->{revtrans}) = $sth->fetchrow_array;
  }

 # $sth->finish;

  # get chart of accounts
  $query = qq|SELECT accno,description
              FROM chart
	      WHERE charttype = 'A'
              ORDER by accno|;
  $sth = $dbh->prepare($query);
  $sth->execute || $form->dberror($query);
  $form->{chart} = "";
  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
    $form->{chart} .= "$ref->{accno}--$ref->{description}\n";
   $form->{chart2} .= "<option value='$ref->{accno}--$ref->{description}'>$ref->{accno}--$ref->{description}\n";
   }
  $sth->finish;

  $dbh->disconnect;
};

sub post_transaction {
  my ($self, $myconfig, $form) = @_;

  my ($amount, $credit) = (0, 0);
  $form->{transno} += 1;
  $form->{callback}.= "&transdate=$form->{transdate}&transtype=$form->{transtype}&batch=$form->{batch}&arap=$form->{arap}&transno=$form->{transno}&subtransno=$form->{subtransno}";

  my $i;
  # check if debit and credit balances

 for $i (1 .. $form->{rowcount}) {
    if ($form->{"debit_$i"} && $form->{"credit_$i"}) {
      return -1;
    }

    $form->{"debit_$i"} = $form->parse_amount($myconfig, $form->{"debit_$i"});
    $form->{"credit_$i"} = $form->parse_amount($myconfig, $form->{"credit_$i"});

    $debit += $form->{"debit_$i"};
    $credit += $form->{"credit_$i"};
  }

  $debit = $form->round_amount($debit, 2);
  $credit = $form->round_amount($credit, 2);

  if ($debit != $credit) {
    return -2;
  }
  


  # connect to database, turn off AutoCommit
  my $dbh = $form->dbconnect_noauto($myconfig);


  # post the transaction
  # make up a unique handle and store in source field
  # then retrieve the record based on the unique handle to get the id
  # replace the source field with the actual variable
  # add records to acc_trans

  # if there is a $form->{id} replace the old transaction
  # delete all acc_trans entries and add the new ones

  # escape '

  my ($query, $uid, $sth);

   $uid = time;
    $uid .= $form->{login};




my $total=0;
my $type=1;
 # $transdate = $form->datetonum($form->{"transdate"}, \%myconfig);
 # $closedto = $form->datetonum($form->{closedto}, \%myconfig);

  # this is just for the wise guys
 # $form->error($locale->text('Cannot post transaction for a closed period!')) if ($transdate <= $closedto);



 $form->{"transno_$i"} =~ s/'/\\'/g;
  $form->{"batch_$i"} =~ s/'/\\'/g;
  $form->{"transtype_$i"} =~ s/'/\\'/g;
  $form->{"subtransno_$i"} =~ s/'/\\'/g;
  


    # if there is an amount, add the record
if ($form->{id}) {
      $query = qq|update  ou set
      			transtype='$form->{"transtype"}',
      			batch='$form->{"batch"}'
		   where id=$form->{id}
      |;
#$form->dberror($query);
      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

  } else {


	#$form->dberror($type);

      $query = qq|INSERT INTO ou (transtype, employee_id,batch)
		  VALUES
		  ('$uid',(SELECT id FROM employee WHERE login = '$form->{login}'),'$form->{"batch"}')|;
	
	#$form->dberror($query);
      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 


        # retrieve id
    $query = qq|SELECT id
                FROM ou
		WHERE transtype = '$uid'|;
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    ($form->{id}) = $sth->fetchrow_array;
    $sth->finish;

   $query = qq|UPDATE ou SET transtype = '$form->{transtype}'
                WHERE transtype = '$uid'|;

#    $form->dberror($query);
    $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

     }

 if ($form->{id}) {
    # delete individual transactions
    $query = qq|DELETE FROM acc_trans
                WHERE trans_id = $form->{id}|;
    $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

   $query = qq|DELETE FROM ou_trans
                WHERE id = $form->{id}|;
    $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 
  } else {

    $query = qq|SELECT id FROM ou WHERE transtype = '$uid'|;
    $sth = $dbh->prepare($query);
    $sth->execute || $form->dberror($query);

    ($form->{id}) = $sth->fetchrow_array;

    $sth->finish;
  }


  # insert acc_trans transactions
  for $i (1 .. $form->{rowcount}) {
    # extract accno
    ($accno) = split(/--/, $form->{"accno_$i"});


    # if there is an amount, add the record
    if ($form->{"debit_$i"} != 0) {
   $amount = $form->{"debit_$i"}*-1;
      $query = qq|INSERT INTO acc_trans (trans_id, chart_id, amount, transdate,
                  source)
		  VALUES
		  ($form->{id}, (SELECT id
		                 FROM chart
				 WHERE accno = '$accno'),
		   $amount, '$form->{"transdate_$i"}', '$form->{"source_$i"}' )|;

      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

      $query = qq|INSERT INTO ou_trans (id, chart_id, amount, transdate,
                  source,transno,subtransno,description)
		  VALUES
		  ($form->{id}, (SELECT id
		                 FROM chart
				 WHERE accno = '$accno'),
		   $amount, '$form->{"transdate_$i"}', '$form->{"source_$i"}' ,
		   '$form->{"transno_$i"}','$form->{"subtransno_$i"}','$form->{"description_$i"}'
		   )|;

      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

  }

   if ($form->{"credit_$i"} != 0) {
   $amount = $form->{"credit_$i"};
      $query = qq|INSERT INTO acc_trans (trans_id, chart_id, amount, transdate,
                  source)
		  VALUES
		  ($form->{id}, (SELECT id
		                 FROM chart
				 WHERE accno = '$accno'),
		   $amount, '$form->{"transdate_$i"}', '$form->{"source_$i"}' )|;

      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

      $query = qq|INSERT INTO ou_trans (id, chart_id, amount, transdate,
                  source,transno,subtransno,description)
		  VALUES
		  ($form->{id}, (SELECT id
		                 FROM chart
				 WHERE accno = '$accno'),
		   $amount, '$form->{"transdate_$i"}', '$form->{"source_$i"}' ,
		   '$form->{"transno_$i"}','$form->{"subtransno_$i"}','$form->{"description_$i"}'
		   )|;

      $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

  }
  }

  # commit and redirect
  my $rc = $dbh->commit;
  $dbh->disconnect;

  $rc;

}

sub delete_transaction {
  my ($self, $myconfig, $form) = @_;

  # connect to database
  my $dbh = $form->dbconnect_noauto($myconfig);

  my $query = qq|DELETE FROM gl WHERE id = $form->{id}|;
  $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

  $query = qq|DELETE FROM acc_trans WHERE trans_id = $form->{id}|;
  $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 

  $query = qq|DELETE FROM ou_trans WHERE id = $form->{id}|;
  $dbh->do($query) || $form->dberror($query);  $form->save_query(\%$form,$myconfig->{dbname},$query); 
  
  # commit and redirect
  my $rc = $dbh->commit;
  $dbh->disconnect;

  $rc;

}

1;
