use SL::GL_ALL;
use POSIX qw(strftime);
1;

sub search {

 # $form->{title} .= " ".$locale->text('Reports');

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<!--input type=hidden name=sort value=transdate-->
<input type=hidden name=sort value=transno>
<input type=hidden name=title value="$form->{title}">

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>
<tr>
  <th align=right>|.$locale->text('From').qq| ($myconfig{dateformat})</th>
  <td><input name=datefrom size=11></td>
  <th align=right>|.$locale->text('To').qq|</th>
  <td><input name=dateto size=11></td>

</tr>
<tr>
|;
#if($form->{subtitle} eq "GENERAL LEDGER"){
  print qq|<th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>
    <input name="category" class=radio type=radio value=X checked>&nbsp;|.$locale->text('All').qq|
    <input name="category" class=radio type=radio value=A>&nbsp;|.$locale->text('Asset').qq|
    <input name="category" class=radio type=radio value=L>&nbsp;|.$locale->text('Liability').qq|
    <input name="category" class=radio type=radio value=Q>&nbsp;|.$locale->text('Equity').qq|
    <input name="category" class=radio type=radio value=I>&nbsp;|.$locale->text('Income').qq|
    <input name="category" class=radio type=radio value=E>&nbsp;|.$locale->text('Expense').qq|<br>
    <input name="l_sr" class=checkbox type=checkbox value=Y $form->{l_sr}>&nbsp;|.$locale->text('SR').qq|
    <input name="l_id" class=checkbox type=checkbox value=Y $form->{l_id}>&nbsp;|.$locale->text('ID').qq|
    <input name="l_transdate" class=checkbox type=checkbox value=Y $form->{l_transdate}>&nbsp;|.$locale->text('Date').qq|
    <input name="l_source" class=checkbox type=checkbox value=Y $form->{l_source}>&nbsp;|.$locale->text('Ref No').qq|
    <input name="l_description" class=checkbox type=checkbox value=Y $form->{l_description}>&nbsp;|.$locale->text('Description').qq|<br>
    <input name="l_debit" class=checkbox type=checkbox value=Y $form->{l_debit}>&nbsp;|.$locale->text('Debit').qq|
    <input name="l_credit" class=checkbox type=checkbox value=Y $form->{l_credit}>&nbsp;|.$locale->text('Credit').qq|
    <input name="l_accno" class=checkbox type=checkbox value=Y $form->{l_accno}>&nbsp;|.$locale->text('Account').qq|
    <input name="l_accdesc" class=checkbox type=checkbox value=Y $form->{l_accdesc}>&nbsp;|.$locale->text('Account Description').qq|
    <input name="l_batch" class=checkbox type=checkbox value=Y $form->{l_batch}>&nbsp;|.$locale->text('Trans No.').qq|
    <input name="l_project" class=checkbox type=checkbox value=Y $form->{l_project}>&nbsp;|.$locale->text('Project No.').qq|
    <input name="l_subb" class=checkbox type=checkbox value=Y $form->{l_subb}>&nbsp;|.$locale->text('Sub No.').qq|
    <input name="l_gifi_accno" class=checkbox type=checkbox value=Y $form->{l_gifi_accno}>&nbsp;|.$locale->text('GIFI').qq|<br>
    <input name="l_amount" class=checkbox type=checkbox value=Y $form->{l_amount}>&nbsp;|.$locale->text('Amount').qq|
    <input name="l_subtotal" class=checkbox type=checkbox value=Y $form->{l_subtotal}>&nbsp;|.$locale->text('Subtotal').qq|
    <input name="l_total" class=checkbox type=checkbox value=Y $form->{l_total}>&nbsp;|.$locale->text('Total').qq|

    </td>
  </tr>|;
#}

print qq|
</table>
</td>

</tr>
</table>
<input type=hidden name=rowcount value=$form->{rowcount}>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>
<br>
<input class=submit type=submit name=action value="|.$locale->text('Generate GL Report').qq|">
<input class=submit type=submit name=action value="|.$locale->text('Generate GL Report Print').qq|">
</form>

<p>
|.$locale->text('To display all transactions, leave fields blank')

  .qq|

</body>
</html>
|;
}


sub generate_gl_report_print {
	$form->{print}="true";
	&generate_gl_report;
}

sub generate_gl_report {
	&generate_gl_report_all;
}

sub generate_gl_report_all{
	$form->{rowcount}=30;
   map { $form->{$_} = $myconfig{$_} } (qw(company address businessnumber nativecurr fy));
 if(!$form->{print}){
    $listheading="class=listheading";
    $listheadingcolor="color=ffffff";
    $listtop="class=listtop";
    $listrow="class=listrow";
    $listtotal="class=listtotal";
    $listsubtotal="class=listsubtotal";
    $lastline=$locale->text('Click on "Ref No." to edit transaction');
  }else{
    $line = "<hr size=3 noshade>";
    $fontsize="size=2";
    $listprint="class=print";
    $listheading="class=print";
    $listtop="class=print";
    $listrow="class=print";
    $listsubtotal="class=print";
  }
  
  GL_ALL->all_transactions1(\%myconfig, \%$form);

  #14/10 Change to Cheque No in BP
  $form->{transtypeno1} = $form->{transtypeno};
  $form->{transtypeno1} =~ tr/0123456789-//d;
  
   $form->{title} =~ s/ /%20/g;
   
   $callback = "$form->{script}?action=generate_report&path=$form->{path}&login=$form->{login}&password=$form->{password}&print=$form->{print}&title=$form->{title}&nextfocus=transtype";
   $form->{title} =~ s/%20/ /g;
   
  %acctype = ( 'A' => $locale->text('Asset'),
               'L' => $locale->text('Liability'),
	       'Q' => $locale->text('Equity'),
	       'I' => $locale->text('Income'),
	       'E' => $locale->text('Expense'),
	     );

  unless ($form->{category} eq 'X') {
    $form->{title} .= " : ".$locale->text($acctype{$form->{category}});
  }
  if ($form->{accno}) {
    $callback .= "&accno1=$form->{accno1}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Account')." : $form->{accno} $form->{U_description}";
  }
  if ($form->{accdesc}) {
    $callback .= "&accdesc=$form->{accdesc}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Account Desc.')." : $form->{accdesc} $form->{account_description}";
  }
    if ($form->{transtypeno}) {
    $callback .= "&transtypeno=$form->{transtypeno}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Trans Type.')." : $form->{transtypeno} $form->{transtype}";
  }
  if ($form->{batchno}) {
    $callback .= "&batchno=$form->{batchno}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Batch No.')." : $form->{batchno} $form->{batch}";
  }
  if ($form->{transnono}) {
    $callback .= "&transnono=$form->{transnono}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Trans No.')." : $form->{transnono} $form->{transno}";
  }
    if ($form->{subtransnono}) {
    $callback .= "&subtransnono=$form->{subtransnono}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Sub Trans No.')." : $form->{subtransnono} $form->{subtransno}";
  }
    if ($form->{subb}) {
    $callback .= "&sub=$form->{subb}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Sub No.')." : $form->{subb} $form->{subb}";
  }
 if ($form->{project}) {
    $callback .= "&project=$form->{project}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Project No.')." : $form->{project} $form->{project}";
  }
  if ($form->{gifi_accno}) {
    $callback .= "&gifi_accno=$form->{gifi_accno}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('GIFI')." : $form->{gifi_accno} $form->{gifi_account_description}";
  }
  if ($form->{source}) {
    $callback .= "&source=".$form->escape($form->{source});
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Ref No.')." : $form->{source}";
  }
  if ($form->{description}) {
    $callback .= "&description=".$form->escape($form->{description});
    $option .= "\n<br>" if $option;
    $option .= $locale->text('Description')." : $form->{description}";
  }
  if ($form->{datefrom}) {
    $callback .= "&datefrom=$form->{datefrom}";
    $option .= "\n<br>" if $option;
    $option .= $locale->text('From')." ".$locale->date(\%myconfig, $form->{datefrom}, 1);
  }
  if ($form->{dateto}) {
    $callback .= "&dateto=$form->{dateto}";
    if ($form->{datefrom}) {
      $option .= " ";
    } else {
      $option .= "\n<br>" if $option;
    }
    $option .= $locale->text('To')." ".$locale->date(\%myconfig, $form->{dateto}, 1);
  }
  
  
  if($form->{transtypeno1} eq "BP"){
	$sourceheading =$locale->text('Cheque No.');
  }
  else{
  	$sourceheading =$locale->text('Ref No.');
  }

  if($form->{title} eq "GENERAL%20LEDGER"){
  $sourceheading =$locale->text('Ref No.');
}
if($form->{title} eq "GENERAL%20JOURNAL"){
  $sourceheading =$locale->text('Ref No.');
}
if($form->{title} eq "OPENING%20BALANCE"){
  $form->{title} = $locale->text('Opening Balance as at ').$form->{datefrom};
  $sourceheading =$locale->text('Ref No.');
}
if($form->{title} eq "OUTSTANDING%20INVOICE"){
  $sourceheading =$locale->text('Bill No.');
}

if($form->{title} eq "BANK%20PAYMENT"){
  $sourceheading =$locale->text('Cheque No.');
  $lastline2 = 'Y';
}
if($form->{title} eq "BANK%20RECEIPT"){
   $sourceheading =$locale->text('O/R No.');
   $lastline2 = 'Y';
}
if($form->{title} eq "CASH%20PAYMENT"){
   $sourceheading =$locale->text('Bill No.');
   $lastline2 = 'Y';
}
if($form->{title} eq "CASH%20RECEIPT"){
 $sourceheading =$locale->text('O/R No.');  $lastline2 = 'Y';

}

  #@columns = $form->sort_columns(qw(batch project subb transdate  id  source   accno accdesc   gifi_accno debit credit amount));
  @columns = qw( project subb transdate batch id  source   accno accdesc   gifi_accno debit credit amount);
  
  @columns = grep !/amount/, @columns;
  @columns = grep !/accno/, @columns;
  
  if ($form->{accno}) {
    @columns = grep !/accno/, @columns;
  }
  if ($form->{accdesc}) {
    @columns = grep !/accdesc/, @columns;
  }
  if ($form->{batch}) {
    @columns = grep !/batch/, @columns;
  } 
  if ($form->{subb}) {
    @columns = grep !/subb/, @columns;
  }
  if ($form->{project}) {
    @columns = grep !/project/, @columns;
  }
  if ($form->{gifi_accno}) {
    @columns = grep !/gifi_accno/, @columns;
  }

  $href = "$callback&sort=$form->{sort}";        # needed for accno

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }

  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }

  if ($form->{l_total} eq 'Y') {
    $callback .= "&l_total=Y";
    $href .= "&l_total=Y";
  }
    if ($form->{l_description} eq 'Y') {
    $callback .= "&l_description=Y";
    $href .= "&l_description=Y";
  }
  
    if ($form->{l_sr} eq 'Y') {
    $callback .= "&l_sr=Y";
    $href .= "&l_sr=Y";
  }

  $callback .= "&category=$form->{category}";
  $href .= "&category=$form->{category}";

  
     if ($form->{l_description} eq 'Y') {
   	$description =$locale->text('Account Name & Description');
  }else{
    	$description =$locale->text('Account Name & Description');

  }
  
  #$column_header{sr} = "<th $listprint ><font $fontsize $listheadingcolor>".$locale->text('SR')."$line</th>";
  $column_header{id} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=id>".$locale->text('ID')."</a>$line</th>";
  $column_header{transdate} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=transdate>".$locale->text('Date')."</a>$line</th>";
  $column_header{source} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=source>".$sourceheading."</a>$line</th>";
  #$column_header{description} = "<th $listprint ><a $listprint href=$callback&sort=description><font $fontsize $listheadingcolor>".$locale->text('Description')."</a>$line</th>";
  $column_header{debit} = "<th $listprint nowrap>$line".$locale->text('Debit')."$line</th>";
  $column_header{credit} = "<th $listprint nowrap>$line".$locale->text('Credit')."$line</th>";
  $column_header{amount} = "<th $listprint nowrap>$line".$locale->text('Amount')."$line</th>";
  $column_header{accno} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=accno>".$locale->text('Account')."</a>$line</th>";
  $column_header{accdesc} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=accno>".$description."</a>$line</th>";
  $column_header{batch} = "<th $listprint nowrap >$line<a $listprint href=$callback&sort=transtype,batch,transno,subtransno>".$locale->text('Trans No.')."</a>$line</th>";
  $column_header{subb} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=subb>".$locale->text('Sub No.')."</a>$line</th>";
  $column_header{project} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=project>".$locale->text('Project No.')."</a>$line</th>";
  $column_header{gifi_accno} = "<th $listprint nowrap>$line<a $listprint href=$callback&sort=gifi_accno>".$locale->text('GIFI')."</a>$line</th>";

  $colspan = $#column_index + 1;

  $form->header;  
  
  #14/10 determine the title in GL
  $form->{transtypeno2} = $form->{transtypeno};
  $form->{transtypeno2} =~ tr/0123456789-//d;
  
  #15/10 set latest date and time
  $nowdate = strftime "%d%m%y", localtime;
  $nowtime = strftime "%I%M ", localtime;	
	
  #10/10 extract the db name
  ($dbname) = split /\_/, $myconfig{dbname};
  $dbname =~ tr/a-z/A-Z/;  
  
  #14/10 page number at right upper corner
  $pagenumber = 1;
  
  #14/10 move the company name and title to top of the page
  print  qq|

<body bgcolor=ffffff $listprint>
<table border=0 width=100%>
	<tr>
		<td align=left width=100>
		<table border=0>
		<tr>
			<th align=left><font size=3>$dbname</font></th>
		</tr>
		<tr>
			<th align=left nowrap><font size=3>F/Y : $form->{fy}</font></th>
		</tr>
		</table>								
		<th align=center>$form->{company}<br>GENERAL LEDGER FOR JAN $form->{fy} - DEC $form->{fy}</th>
		</td>
		<td align=left width=100 valign=bottom nowrap>PG. $pagenumber</td>
	</tr>
</table>
|;

$glref++;
 print  qq|
	<table $listprint border=0 width=100%>
	<thead $listheading >
  |;
  print qq|<tr>
  		<td colspan=2>A/C No.:&nbsp;$ref->{accno}</td>
		<td colspan=3>A/C NAME:&nbsp;$ref->{accdesc}</td>
		<td align=right>GL REF:&nbsp;$glref&nbsp;</td>
	   </tr>|;
      if($form->{l_sr}){
		print "<th $listprint>$line".$locale->text('SR')."$line</th>";
    }

  map { print "$column_header{$_}\n" } @column_index;
  #&print_table_header;
  print  "</thead>";
  $done="true";
  # add sort to callback
  $callback = $form->escape($callback . "&sort=$form->{sort}");

  # initial item for subtotals
  if (@{ $form->{GL} }) {
    $sameitem = $form->{GL}->[0]->{$form->{sort}};
  }

  
  ###############################################################loop
    foreach $ref (@{ $form->{GL} }) {
	    if($glref==1 and !$done){
 
	    }
	    
	    
    # if item ne sort print subtotal
    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ref->{$form->{sort}}) {
	&gl_subtotal;
      }
    }
	$ref->{debit1}=$ref->{debit};
		$ref->{credit1}=$ref->{credit};
	$form->{temp} = $ref->{transtype};
	$form->{temp} =~ tr/0123456789-//d;
	if($form->{temp} eq "OB"){
		$number++;
		$number1=$number;
		$ref->{transno}="";
		$ref->{subtransno}="";
		$ref->{batch}="";
		#OBs value are not needed in GRAND TOTAL		
		$ref->{debit1}=0;
		$ref->{credit1}=0;
	}
	else{	$number1="";}
	
    $subtotaldebit += $ref->{debit};
    $subtotalcredit += $ref->{credit};
    $subtotalamount += $ref->{amount};

    $totaldebit += $ref->{debit1};
    $totalcredit += $ref->{credit1};
    $totalamount += $ref->{amount};    
    
    #total the +ve amount amount
    if($ref->{amount} > 0){
    	$pagetotalamount += $ref->{amount};
    }
    if($ref->{credit} > 0){
	  $ref->{credit} = $ref->{credit} * -1;
  }
    $pagetotaldebit += $ref->{debit};
    $pagetotalcredit += $ref->{credit};
 
    	if($ref->{description} eq""){	$aaa="INVOICE OF ".$ref->{source};}
	else{	$aaa="";}
 
    $ref->{debit} = $form->format_amount(\%myconfig, $ref->{debit}, 2, "&nbsp;");
    $ref->{credit} = $form->format_amount(\%myconfig, $ref->{credit}, 2, "&nbsp;");
    $ref->{amount} = $form->format_amount(\%myconfig, $ref->{amount}, 2, "&nbsp;");
    $j++;
      
    #$column_data{sr} = "<td $listprint><font $fontsize >$j</td>";
    $column_data{id} = "<td $listprint>$ref->{id}</td>";
    $column_data{transdate} = "<td $listprint width=80>$ref->{transdate}</td>";
    $column_data{source} = "<td $listprint><!--a  $listprint href=$ref->{module}.pl?action=edit&nextfocus=transtype&id=$ref->{id}&vc=$form->{vc}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback-->$ref->{source}</td>";
    #$column_data{description} = "<td $listprint><font $fontsize >$ref->{description}</td>";
    $column_data{debit} = "<td align=right $listprint width=75>$ref->{debit}</td>";
    $column_data{credit} = "<td align=right $listprint width=75>$ref->{credit}</td>";
    $column_data{amount} = "<td align=right $listprint>$ref->{amount}</td>";
    $column_data{accno} = "<td $listprint>$ref->{accno}</td>";
    $column_data{accdesc} = "<td width=40% $listprint>$aaa$ref->{description}</td>";
    $column_data{batch} = "<td $listprint><!--a $listprint  href=$ref->{module}.pl?action=edit&nextfocus=transtype&id=$ref->{id}&vc=$form->{vc}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback-->$ref->{transtype}$ref->{batch}$ref->{transno}$number1$ref->{subtransno}<!--/a--></td>";
    $column_data{subb} = "<td $listprint>$ref->{subb}</td>";
    $column_data{project} = "<td $listprint>$ref->{project}</td>";
    $column_data{gifi_accno} = "<td $listprint>$ref->{gifi_accno}&nbsp;</td>";
  
    $i++; $i %= 2;    
    #$r++;
    
    print  "<tr $listrow$i>";

     
     if($ref->{source} eq ""){
	     $ref->{accno} = $form->{account};
     }
 
     if($pagenumber==1){
	     $pgnb++;
     }
    
    #26/10 print each and every accounts 
    if($ref->{accno} == $form->{account}){    
	    $NOT++;
	    ++$r;
	    if($form->{l_sr}){
		print "<td $listprint>$j</td>";
	    }
    	   map { print "$column_data{$_}\n" } @column_index;
	    $ref->{debit} =~ s/,//g;
	    $ref->{credit} =~ s/,//g;		
    }
    else{	  #The GL Ref
    		$glref++;   
		$subglref = $glref;
	    if($pgnb==1){
		   	$rows = "";
			$pagebreak="";
			$pgnb++;
	    }
	    else{
		    	$pagebreak = "<p style=\"page-break-before: always\">&nbsp;</p>";
		    	$totalaccno = $newdebit +$newcredit;
		    	$NOT++;
			 $r++;
			 $current_not=--$j;
			 $total_not+=$j;
			$rows="<tr><td colspan=4></td><td align=right><hr noshade>".$form->format_amount(\%myconfig, $newdebit , 2, "&nbsp;")."<hr noshade></td><td align=right><hr noshade>".$form->format_amount(\%myconfig, $newcredit , 2, "&nbsp;")."<hr noshade></td></tr>
			<tr><td>&nbsp;</td><td colspan=2>N.O.T.:$current_not</td><td colspan=2 align=center>***TOTAL OF A/C NO.:&nbsp;$form->{account}</td><td>".$form->format_amount(\%myconfig, $totalaccno , 2, "&nbsp;")."</td></tr>
			";
	    }	
	    	$newdebit = 0;
		$newcredit = 0;
		$temp = $current_not;
		#$pagebreak="";
		#if($NOT<3){
		$pbcount += $temp + 5;
		$pagenumber++;
		
	#if($NOT<3){
			#$pbcount++;
	#		$pagebreak = "";			
				
	#	if($pbcount >= 30){
		#	$pagebreak = "<p style=\"page-break-before: always\">&nbsp;</p>";
			$header = "<tr><td colspan=6><table border=0 width=100%>
					<td align=left width=80>
						<table border=0 >
						<tr>
							<th align=left><font size=3>$dbname</font></th>
						</tr>
						<tr>
							<th align=left nowrap><font size=3>F/Y : $form->{fy}</font></th>
						</tr>
						</table>
						<th align=center width=500>$form->{company}<br>GENERAL LEDGER FOR JAN $form->{fy} - DEC $form->{fy}</th>
					</td>
					<td align=left width=50 valign=bottom nowrap>PG. $pagenumber</td>
					</table></td></tr>
					<tr><td>&nbsp;</td></tr><tr><td>&nbsp;</td></tr>";
#					$pbcount=0
				
#		}
#	}else{
		#	$pagebreak = "<p style=\"page-break-before: always\">&nbsp;</p>";
#			$header = "<tr><td colspan=6><table border=0 width=100%>
#					<td align=left width=80>
#						<table border=0 >
#						<tr>
#							<th align=left><font size=3>$dbname</font></th>
#						</tr>
#						<tr>
#							<th align=left nowrap><font size=3>F/Y : $form->{fy}</font></th>
#						</tr>
#						</table>
#						<th align=center width=500>$form->{company}<br>GENERAL LEDGER FOR JAN $form->{fy} - DEC $form->{fy}</th>
#					</td>
#					<td align=left width=50 valign=bottom nowrap>PG. $pagenumber</td>
#					</table></td></tr>
#					<tr><td>&nbsp;</td></tr><tr><td>&nbsp;</td></tr>";
#		}
		$pbcount = 0;
		$j=1;
		$r+=5;
	    	print qq|
	    	$rows
		<table $listprint border=0 width=100%>
			$pagebreak
	
		<thead $listheading >
		$header
		<tr><td colspan=2>A/C No.:&nbsp;$ref->{accno}</td><td colspan=3>A/C NAME:&nbsp;$ref->{accdesc}</td><td align=right>GL REF:&nbsp;$glref&nbsp;</td></tr>
		|;
		$header="";
		      if($form->{l_sr}){
		print "<th $listprint>$line".$locale->text('SR')."$line</th>";
		      	}
	    	map { print  "$column_header{$_}\n" } @column_index;
	    	print  "</thead>";
		   $i++; $i %= 2;    
    #$r++;
    
    		print  "<tr $listrow$i>";
 	    if($form->{l_sr}){
		print "<td $listprint>$j</td>";
	    }
	    map { print "$column_data{$_}\n" } @column_index;
	    print "</tr>";
      		$NOT = 0;
		
		 $r=0;
    		$ref->{debit} =~ s/,//g;
		$ref->{credit} =~ s/,//g;
    }		
		$newdebit += $ref->{debit};
		$newcredit += $ref->{credit};
		
    		$form->{account} = $ref->{accno};
		$form->{adddesc} = $ref->{source};
		$form->{adddesc} = $ref->{source};
    print  "</tr>"; 
    $pagebreak = "";
    #pagebreak printing
if($form->{rowcount} && $form->{print} && $form->{rowcount} <= $r){
	 
$pagenum++;
    print "<tr $listrow$i >";
if($form->{l_sr}){
	print "<td $listprint >&nbsp;</td>";
}

    map { $column_data{$_} = "<td $listprint >&nbsp;</td>" } @column_index;
    $column_data{accdesc} = "<td $listprint align=center>***SUBTOTAL</td>";
    #$column_data{amount} = "<td  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."</td>";
    $column_data{debit} = "<td  $listprint align=right>$line".$form->format_amount(\%myconfig, $newdebit , 2, "&nbsp;")."$line</td>";
    $column_data{credit} = "<td  $listprint align=right>$line".$form->format_amount(\%myconfig, $newcredit, 2, "&nbsp;")."$line</td>";
  
     map { print "\n$column_data{$_}" } @column_index;
    
     #14/10
     ($dbname) = split /\_/, $myconfig{dbname};
     $dbname =~ tr/a-z/A-Z/;
     
     #15/10 set the page number
     $pagenumber++;
     
     #16/10 show the date, time and title and the bottom
     print qq|
     <!--tr><td>&nbsp;</td></tr>
     <tr><td>&nbsp;</td></tr>
     </tr>
     <tr>
     <td></td>
     <td colspan=2>$form->{titlebottom}</td>
     <td></td>
     <td align=right colspan=3>$nowdate-$nowtime</td>
     </tr>
     
     <#14/10 changing the table-->
    
</table>
 <p style="page-break-before: always">&nbsp;</p>
 <table border=0 width=100%>
	<tr>
		<td align=left >
		<table border=0 >
		<tr>
			<th align=left><font size=3>$dbname</font></th>
		</tr>
		<tr>
			<th align=left nowrap><font size=3>F/Y : $form->{fy}</font></th>
		</tr>
		</table>
		<th align=center>$form->{company}<br>GENERAL LEDGER FOR JAN $form->{fy} - DEC $form->{fy}</th>
		</td>
		<td align=left width=50 valign=bottom nowrap>PG. $pagenumber</td>
	</tr>
</table>

<table  $listprint border=0 width=100%>
<tr><td colspan=2>A/C No.:&nbsp;$ref->{accno}</td><td colspan=3>A/C NAME:&nbsp;$ref->{accdesc}</td><td align=right>GL REF:&nbsp;$subglref&nbsp;</td></tr>
<!--tr $listheading-- >|;
	if($form->{l_sr}){
		print "<th $listprint>$line".$locale->text('SR')."$line</th>";
	}
	map { print  "$column_header{$_}\n" } @column_index;	

print qq|
</tr><tr>
|;
	if($form->{l_sr}){
		print "<td $listprint >&nbsp;</td>";
	}
	$pagenumber1=$pagenumber-1;

	
 	  map { $column_data{$_} = "<td $listprint >&nbsp;</td>" } @column_index;
    $column_data{accdesc} = "<td $listprint >***Subtotal B/F for Page $pagenumber1 </td>";
    #$column_data{amount} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."</td>";
    $column_data{debit} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $newdebit , 2, "&nbsp;")."</td>";
    $column_data{credit} = "<td  $listprint align=right>".$form->format_amount(\%myconfig, $newcredit, 2, "&nbsp;")."</td>";
    map { print "\n$column_data{$_}" } @column_index;
print qq|
</tr>
|;
$r=0;

}
  }
  #&gl_subtotal if ($form->{l_subtotal} eq 'Y');  
  
  $subtotalheading =$locale->text('***Grand Total:');

  map { $column_data{$_} = "<td >&nbsp;</td>" } @column_index;

  $column_data{accdesc} = "<th $listprint align=right>".$subtotalheading."</th>";
  $column_data{debit} = "<th  $listprint align=right>Dr: ".$form->format_amount(\%myconfig, $totaldebit, 2, "&nbsp;")."$line</th>";
  $column_data{credit} = "<th  $listprint align=right>Cr: ".$form->format_amount(\%myconfig, $totalcredit, 2, "&nbsp;")."$line</th>";
  #$column_data{amount} = "<th  $listprint align=right>$line".$form->format_amount(\%myconfig, $pagetotalamount, 2, "&nbsp;")."$line</th>";

  if($lastline2 eq 'Y' ){
	$lastline = "<p align=right>".$locale->text('Total for BAT NO. ').$form->{transtypeno}."-".$form->{batchno}."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ".$form->format_amount(\%myconfig, $totaldebit, 2, "&nbsp;")."</p><br>".$lastline;
  }
  
  $totalaccno = $newdebit+$newcredit;
  $newdebit = $form->format_amount(\%myconfig, $newdebit, 2, "&nbsp;");
  $newcredit = $form->format_amount(\%myconfig, $newcredit, 2, "&nbsp;");
  $totalaccno = $form->format_amount(\%myconfig, $totalaccno, 2, "&nbsp;");
  $totaldebit = $form->format_amount(\%myconfig, $totaldebit, 2, "&nbsp;");
  $totalcredit = $form->format_amount(\%myconfig, $totalcredit, 2, "&nbsp;");
  if($form->{l_total} eq 'Y'){
	  $NOT++;
	   $r++;
	  $totalNOT+=$NOT;
	  $total_not+=$j;
	  print qq|<tr><td colspan=4></td>
	  <td align=right><hr noshade>$newdebit&nbsp;<hr noshade></td>
	  <td align=right><hr noshade>$newcredit&nbsp;<hr noshade></td>
	  </tr>
	  <tr><td>&nbsp;</td><td colspan=2>N.O.T.: $NOT</td><td colspan=2 align=center>***TOTAL OF A/C NO.:&nbsp;$form->{account}</td><td>$totalaccno&nbsp;</td></tr>
	  <tr><td>&nbsp;</td></tr>
	  <tr><td>&nbsp;</td></tr>
	  <tr><td colspan=2>TOTAL N.O.T.: $total_not</td><td colspan=2 nowrap>$line***GRAND TOTAL: Dr:&nbsp;&nbsp;$totaldebit&nbsp;&nbsp;&nbsp;Cr:&nbsp;&nbsp;$totalcredit$line</td></tr>
	  |;
	  print  qq|
	  <tr $listtotal bgcolor=000000>|;
    
    	if($form->{l_sr}){
    	print "<td $listprint>&nbsp;</td>";
    }

    	#map { print  "$column_data{$_}\n" } @column_index;
	print  qq|</tr>|;
  };
 
 #22/10 push the $nowdate, $nowtime to the bottom
	 $countrow = $r+2;
	 $form->{rowcount} = 23;
 
 	if($countrow == 23){
		$addrows = "<tr><td>&nbsp;</td></tr>\n<tr><td>&nbsp;</td></tr>";
	}
	elsif($countrow < 23){
		$temp = $form->{rowcount}-$countrow;
		for($i=0; $i<=$temp; $i++){
			$addrows .= "<tr><td>&nbsp;</td></tr>\n";
		}
	}
 
 	print  qq|
	<!--$addrows
	</tr>
	<tr>
	<td></td>
	<td colspan=2 align=left>$form->{titlebottom}</td>
	<td></td>
	<td align=right colspan=3>$nowdate-$nowtime</td>
	</tr-->
	</table>
    	<p>
	$lastline
	</body>
	</html>
	|;
}



sub print_table_header{	
	if($form->{l_sr}){
		print "<th $listprint>$line<font $fontsize $listheadingcolor>".$locale->text('SR')."$line</th>";
	}
	map { print  "$column_header{$_}\n" } @column_index;
}

